## ros-noetic-camera-aravis 4.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

project(camera_aravis)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules)

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  message("${PROJECT_NAME}: You did not request a specific build type: selecting 'Release'.")
  set(CMAKE_BUILD_TYPE Release)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

find_package(catkin REQUIRED COMPONENTS
  roscpp
  nodelet
  std_msgs
  sensor_msgs
  message_generation
  image_transport
  camera_info_manager
  dynamic_reconfigure
  tf
  tf2_ros
)
find_package(Aravis REQUIRED)
find_package(GLIB2 REQUIRED)

generate_dynamic_reconfigure_options(cfg/CameraAravis.cfg)

add_message_files(
   FILES
   CameraAutoInfo.msg
   ExtendedCameraInfo.msg
)

add_service_files(
  FILES
  get_boolean_feature_value.srv
  get_float_feature_value.srv
  get_integer_feature_value.srv
  get_string_feature_value.srv
  set_boolean_feature_value.srv
  set_float_feature_value.srv
  set_integer_feature_value.srv
  set_string_feature_value.srv
)

generate_messages(
   DEPENDENCIES
   std_msgs
   sensor_msgs
)

catkin_package(
    DEPENDS Aravis GLIB2
    CATKIN_DEPENDS roscpp nodelet std_msgs sensor_msgs message_runtime image_transport camera_info_manager dynamic_reconfigure tf tf2_ros
    INCLUDE_DIRS
    LIBRARIES
)

include_directories(cfg
  include
  ${catkin_INCLUDE_DIRS}
  ${Aravis_INCLUDE_DIRS}
  ${GLIB2_INCLUDE_DIRS})

set(LIBRARIES
  ${catkin_LIBRARIES}
  ${Aravis_LIBRARIES}
  glib-2.0
  gmodule-2.0
  gobject-2.0
)

add_library(${PROJECT_NAME}
  src/camera_aravis_nodelet.cpp
  src/camera_buffer_pool.cpp
  src/conversion_utils.cpp
)
target_link_libraries(${PROJECT_NAME} ${LIBRARIES})
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

add_executable(cam_aravis
  src/camera_aravis_node.cpp
)
target_link_libraries(cam_aravis ${PROJECT_NAME} ${LIBRARIES})
add_dependencies(cam_aravis ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(TARGETS cam_aravis
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  FILES_MATCHING PATTERN "*.launch"
  PATTERN ".svn" EXCLUDE
)

install(FILES
  nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-noetic-camera-aravis (4.0.4-1buster) buster; urgency=high

  * Update package maintainer
  * Refactor node params (#21 <https://github.com/FraunhoferIOSB/camera_aravis/issues/21>)
    * Refactor node params
    * Rename extended_camera_info_ -> pub_ext_camera_info_
    * Move stream parameters to the top of onInit()
  * fix: only reset PTP clock when in "Faulty" or "Disabled" state (#23 <https://github.com/FraunhoferIOSB/camera_aravis/issues/23>)
  * Update industrial_ci default branch to main
  * Contributors: Dominik Kleiser, Peter Mortimer, Ruf, Boitumelo

 -- Boitumelo Ruf, Fraunhofer IOSB <boitumelo.ruf@iosb.fraunhofer.de>  Thu, 22 Dec 2022 23:00:00 -0000

ros-noetic-camera-aravis (4.0.3-1buster) buster; urgency=high

  * Refactor image conversion (#20 <https://github.com/FraunhoferIOSB/camera_aravis/issues/20>)
  * Use plain file names for includes (#17 <https://github.com/FraunhoferIOSB/camera_aravis/issues/17>)
  * Add verbose flag for feature detection (default = false) (#19 <https://github.com/FraunhoferIOSB/camera_aravis/issues/19>)
  * Assume num_streams_ = 1 if DeviceStreamChannelCount and GevStreamChannelCount unavailable (#18 <https://github.com/FraunhoferIOSB/camera_aravis/issues/18>)
  * Add Line0 to Line5 to TriggerSource Enum
  * Fix: nodelet namespace
  * Fix: onInit deadlock
  * Contributors: Dominik Kleiser, Boitumelo Ruf, Thomas Emter, Peter Mortimer, tas, Geoff McIver

 -- Dominik Kleiser, Fraunhofer IOSB <dominik.kleiser@iosb.fraunhofer.de>  Thu, 07 Jul 2022 22:00:00 -0000

ros-noetic-camera-aravis (4.0.2-1buster) buster; urgency=high

  * Add optional ExtendedCameraInfo message to publish additional camera acquisition parameters
  * Fix: Set reasonable height and width when not given in the CameraInfo
  * Contributors: Peter Mortimer

 -- Dominik Kleiser, Fraunhofer IOSB <dominik.kleiser@iosb.fraunhofer.de>  Tue, 03 May 2022 22:00:00 -0000

ros-noetic-camera-aravis (4.0.1-1buster) buster; urgency=high

  * Add ROS getter/setter services for camera features
  * Add support for multistream encoding conversion
  * Fix: Pass on the correct encoding for the additional streams of multisource cameras
  * Fix: Continuously check the spawning_ flag
  * Fix: Check spawning_ flag only once during spawnStream
  * Contributors: Peter Mortimer, Thomas Emter, Dominik Kleiser

 -- Dominik Kleiser, Fraunhofer IOSB <dominik.kleiser@iosb.fraunhofer.de>  Thu, 24 Mar 2022 23:00:00 -0000

ros-noetic-camera-aravis (4.0.0-1buster) buster; urgency=high

  * Major refactoring
  * Add support for ROS Noetic and aravis-0.6
  * Fix several bugs (see git history)
  * Add new features:
    
      * Support for multisource cameras
      * Zero-copy transport with ROS nodelets
      * Camera time synchronization
      * Example launch files
    
  * Update package author and maintainer
  * Contributors: Dominik Klein, Floris van Breugel, Gaël Écorchard, Thomas Emter, Peter Mortimer, Dominik Kleiser

 -- Dominik Kleiser, Fraunhofer IOSB <dominik.kleiser@iosb.fraunhofer.de>  Tue, 26 Oct 2021 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-camera-aravis
Section: misc
Priority: optional
Maintainer: Boitumelo Ruf, Fraunhofer IOSB <boitumelo.ruf@iosb.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), aravis-tools, libaravis-0.6-0, libaravis-dev, libglib2.0-dev, ros-noetic-camera-info-manager, ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-image-transport, ros-noetic-message-generation, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf, ros-noetic-tf2-ros
Homepage: https://github.com/FraunhoferIOSB/camera_aravis
Standards-Version: 3.9.2

Package: ros-noetic-camera-aravis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, aravis-tools, libaravis-0.6-0, ros-noetic-camera-info-manager, ros-noetic-dynamic-reconfigure, ros-noetic-image-transport, ros-noetic-message-runtime, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf, ros-noetic-tf2-ros
Description: camera_aravis: A complete and comfortable GenICam (USB3Vision and GigEVision) based camera driver for ROS (ethernet and usb).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-camera-aravis//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
